import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.ImageWriter;
import javax.imageio.ImageWriteParam;
import javax.imageio.stream.ImageOutputStream;
import javax.imageio.stream.ImageInputStream;
import javax.imageio.ImageTypeSpecifier;
import javax.imageio.metadata.IIOMetadata;
import javax.imageio.metadata.IIOMetadataNode;
import javax.imageio.IIOImage;
import java.awt.Color;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.awt.RenderingHints;
import java.io.File;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.util.Iterator;
import java.net.URL;

class UserlogoPrims extends Primitives {


  static String[] primlist={
    "userlaunch", "1", "userrunning?", "0", "userstop", "0", "setusercanvas", "1", "usererror", "0",
    "usermake", "2", "userthing", "1", "userdefined?", "1",
    "saveimage", "1", "savebg", "1", "savebgrect", "5", "loadImage", "2", "setbg", "2",
    "bgtostring", "1", "stringtobg", "2",
    "createbg", "4", "antialias", "1",
    "getpixel", "2", "setpixel", "3", "setratiomask", "2",
    "setpixelimg", "1"
  };


  public String[] primlist(){return primlist;}
  LogoCommandRunner runner;
  BufferedImage pixelimg;


  public Object dispatch(int offset, Object[] args, LContext lc){
    synchronized((lc.canvas==null) ? ((Object)lc) : ((Object) lc.canvas)){
      switch(offset){
      case 0: return prim_userlaunch(args[0],  lc);
      case 1: return prim_userrunning(lc);
      case 2: return prim_userstop(lc);
      case 3: return prim_setusercanvas(args[0],  lc);
      case 4: return prim_usererror(lc);
      case 5: return prim_usermake(args[0], args[1], lc);
      case 6: return prim_userthing(args[0],  lc);
      case 7: return prim_userdefinedp(args[0],  lc);
      case 8: return prim_saveimage(args[0], lc);
      case 9: return prim_savebg(args[0], lc);
      case 10: return prim_savebgrect(args[0], args[1], args[2], args[3], args[4], lc);
      case 11: return prim_loadImage(args[0], args[1], lc);
      case 12: return prim_setbg(args[0], args[1], lc);
      case 13: return prim_bgtostring(args[0], lc);
      case 14: return prim_stringtobg(args[0], args[1], lc);
      case 15: return prim_createbg(args[0], args[1], args[2], args[3], lc);
      case 16: return prim_antialias(args[0], lc);
      case 17: return prim_getpixel(args[0], args[1], lc);
      case 18: return prim_setpixel(args[0], args[1], args[2], lc);
      case 19: return prim_setratiomask(args[0], args[1], lc);
      case 20: return prim_setpixelimg(args[0], lc);
      }
      return null;
    }
  }


  Object prim_userlaunch(Object arg1, LContext lc){
    String cmd = Logo.prs (arg1);
    LContext ulc = TurtleArt.userlogo;
    if(ulc.thread!=null) ulc.timeToStop = true;
    runner = new LogoCommandRunner(cmd, ulc, true);
    new Thread(runner).start();
    return null;
  }

  Object prim_userrunning(LContext lc){
    return new Boolean(runner.running);
  }

  Object prim_userstop(LContext lc){
    TurtleArt.userlogo.timeToStop = true;
    return null;
  }


 Object prim_setusercanvas(Object arg1, LContext lc){
    TurtleArt.userlogo.canvas= lc.canvas;
    TurtleArt.userlogo.turtle= (Sprite)arg1;
    return null;
  }

 Object prim_usererror(LContext lc){
   String error = TurtleArt.userlogo.errormessage;
   TurtleArt.userlogo.errormessage = null;
   if (error==null) error="";
   return error;
 }

 Object prim_usermake(Object arg1, Object arg2, LContext lc){
   Symbol sym = Logo.intern(Logo.prs(arg1), TurtleArt.userlogo);
   Logo.setValue(sym, arg2, TurtleArt.userlogo);
   return null;
 }

 Object prim_userthing(Object arg1, LContext lc){
   Symbol sym = Logo.intern(Logo.prs(arg1), TurtleArt.userlogo);
   return Logo.getValue(sym, TurtleArt.userlogo);
 }

 Object prim_userdefinedp(Object arg1, LContext lc){
   Symbol sym = Logo.intern(Logo.prs(arg1), TurtleArt.userlogo);
   return new Boolean(sym.fcn!=null);
 }


	Object prim_saveimage(Object arg1, LContext lc){
		int dpis = TurtleArt.dpiscale;
 		SpriteCanvas cnv = lc.canvas;
		String name = Logo.prs(arg1);
    BufferedImage img = new BufferedImage(cnv.bg.getWidth(null), cnv.bg.getHeight(null), BufferedImage.TYPE_INT_RGB);
    Graphics2D g = getSaveContext(img);
    g.drawImage(cnv.bg, 0, 0, null);
		g.scale(dpis, dpis);
		g.translate(-cnv.bgx, -cnv.bgy);
		for (int i=cnv.sprites.size()-1;i>=0;i--){
			Sprite spr = (Sprite)cnv.sprites.elementAt(i);
			spr.paint(g);
		}
    g.dispose();
		savePNG(name, img, lc);
		return null;
	}

	Object prim_savebg(Object arg1, LContext lc){
		String name = Logo.prs(arg1);
		savePNG(name, lc.canvas.bg, lc);
		return null;
	}

	Object prim_savebgrect(Object arg1, Object arg2, Object arg3, Object arg4, Object arg5, LContext lc){
		String name = Logo.prs(arg1);
    Object [] r = (Object[])arg2;
    int l=Logo.anInt(r[0],lc), t=Logo.anInt(r[1],lc);
    int w=Logo.anInt(r[2],lc), h=Logo.anInt(r[3],lc);
		int pw=Logo.anInt(arg3,lc), ph=Logo.anInt(arg4,lc);
		int border=Logo.anInt(arg5,lc);
		int dpis = TurtleArt.dpiscale;
    BufferedImage img = new BufferedImage(pw+2*border, ph+2*border, BufferedImage.TYPE_INT_RGB);
    double scale = pw / (double)(w*dpis);
    Graphics2D g = getSaveContext(img);
    g.fillRect(0,0,50000,50000);
    g.setClip(border,border,pw,ph);
    g.translate(border,border);
    g.scale(scale,scale);
    g.translate(-l*dpis,-t*dpis);
    g.setColor(Color.WHITE);
    g.drawImage(lc.canvas.bg, 0, 0, null);
    g.dispose();
		savePNG(name, img, lc);
    return null;
	}

	void savePNG(String name, BufferedImage img, LContext lc){
    try {
        File f = new File(name+".png");
        f.delete();
        ImageWriter writer = null;
        Iterator iter = ImageIO.getImageWritersByFormatName("png");
        if (iter.hasNext()) {
            writer = (ImageWriter)iter.next();
        }
        ImageOutputStream ios = ImageIO.createImageOutputStream(f);
        writer.setOutput(ios);
        writer.write(imageWithDPI(writer, img, lc));
        ios.flush();
        writer.dispose();
        ios.close();
    } catch (Exception e) {Logo.error("savebg problem - "+e, lc);}
	}

	IIOImage imageWithDPI(ImageWriter iw, BufferedImage image, LContext lc){
    try {
			ImageWriteParam iwp = iw.getDefaultWriteParam();
			ImageTypeSpecifier its = new ImageTypeSpecifier(image);
			IIOMetadata imd = iw.getDefaultImageMetadata(its,iwp);
			String format = "javax_imageio_png_1.0";
			IIOMetadataNode tree = (IIOMetadataNode)imd.getAsTree(format);
			IIOMetadataNode node = new IIOMetadataNode("pHYs");
			String dpm = Integer.toString((int)Math.ceil(300/0.0254));
			node.setAttribute("pixelsPerUnitXAxis",dpm);
			node.setAttribute("pixelsPerUnitYAxis",dpm);
			node.setAttribute("unitSpecifier","meter");
			tree.appendChild(node);
			imd.setFromTree(format,tree);
			return new IIOImage(image,null,imd);
    } catch (Exception e) {Logo.error("dpi problem - "+e, lc);}
    return null;
   }

	Graphics2D getSaveContext(BufferedImage img){
    Graphics2D g = (Graphics2D)img.getGraphics();
    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
    g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		return g;
	}

 Object prim_loadImage(Object arg1, Object arg2, LContext lc){
    String filename = Logo.aString(arg1, lc);
    boolean isLocal = Logo.aBoolean(arg2, lc);
    BufferedImage img = null;
    InputStream is;
    try {
			if(isLocal) is = new FileInputStream(new File(filename));
			else is = new URL(filename).openStream();
      ImageReader reader = null;
      Iterator iter = ImageIO.getImageReadersByFormatName("png");
      if (iter.hasNext()) {
          reader = (ImageReader)iter.next();
      }
      ImageInputStream iis = ImageIO.createImageInputStream(is);
      reader.setInput( iis, true );
      img = reader.read(0);
			is.close();
    }
    catch(Exception e) {Logo.error("loadbg problem "+" "+e+" "+filename, lc);}
    return img;
 }

 Object prim_setbg(Object arg1, Object arg2, LContext lc){
    BufferedImage img = (BufferedImage)arg1;
    double s = 1;
	 	double f = ((double)lc.canvas.bg.getWidth(null))/((double)img.getWidth(null));
	 	if(Logo.aBoolean(arg2,lc)) s=f;
    AffineTransform af = AffineTransform.getScaleInstance(s,s);
    Graphics2D g = (Graphics2D)lc.canvas.bg.getGraphics();
    g.drawImage(img, af, null);
    g.dispose();
    lc.canvas.redraw(new Rectangle(0,0,10000,10000));
    return null;
 }

 Object prim_bgtostring(Object arg1, LContext lc){
    Object [] r = (Object[])arg1;
    int l=Logo.anInt(r[0],lc), t=Logo.anInt(r[1],lc);
    int w=Logo.anInt(r[2],lc), h=Logo.anInt(r[3],lc);
    byte[] bytes = imageToByteArray(lc.canvas.bg, new Rectangle(l, t, w, h));
    return byteArrayToHexString(bytes);
  }

  byte[] imageToByteArray(Image source, Rectangle r){
    try {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        BufferedImage img =  new BufferedImage(r.width, r.height, BufferedImage.TYPE_INT_RGB);
        Graphics g = img.getGraphics();
        g.drawImage(source, -r.x, -r.y, null);
        g.dispose();
        ImageWriter writer = null;
        Iterator iter = ImageIO.getImageWritersByFormatName("png");
        if (iter.hasNext()) {
            writer = (ImageWriter)iter.next();
        }
        ImageOutputStream ios = ImageIO.createImageOutputStream(stream);
        writer.setOutput(ios);
        writer.write(img);
        ios.flush(); writer.dispose(); ios.close();
        return stream.toByteArray();
    } catch (Exception e) {return null;}
  }

  String byteArrayToHexString(byte[] bytes){
    StringBuffer buf = new StringBuffer(2*bytes.length);
    for(int offset=0;offset<bytes.length;offset++){
      buf.append(Integer.toHexString((bytes[offset]&0xff)/16));
      buf.append(Integer.toHexString((bytes[offset]&0xff)%16));
      if(offset%32==0) buf.append("\n");
    }
    if(bytes.length%32!=0) buf.append("\n");
    return buf.toString();
  }

 Object prim_stringtobg(Object arg1, Object arg2, LContext lc){
    String str = Logo.aString(arg1, lc);
    Object [] rl = (Object[])arg2;
    int l=Logo.anInt(rl[0],lc), t=Logo.anInt(rl[1],lc);
    int w=Logo.anInt(rl[2],lc), h=Logo.anInt(rl[3],lc);
    Rectangle r = new Rectangle(l, t, w, h);
    byte[] bytes = hexStringToByteArray(str);
    Image img = byteArrayToImage(bytes);
    Graphics g = lc.canvas.bg.getGraphics();
    g.drawImage(img, r.x, r.y, null);
    g.dispose();
    lc.canvas.redraw(r);
    return null;
  }


  byte[] hexStringToByteArray(String str){
    int offset=0;
    ByteArrayOutputStream stream = new ByteArrayOutputStream();
    while(offset<str.length()){
      if(str.charAt(offset)<' ') offset++;
      else {
        int n = Integer.parseInt(str.substring(offset, offset+2), 16);
        stream.write((byte) n);
        offset+=2;
      }
    }
    return stream.toByteArray();
  }

  Image byteArrayToImage(byte[] array){
    try {
      ByteArrayInputStream stream = new ByteArrayInputStream(array);
      ImageReader reader = null;
      Iterator iter = ImageIO.getImageReadersByFormatName("png");
      if (iter.hasNext()) {
          reader = (ImageReader)iter.next();
      }
      ImageInputStream iis = ImageIO.createImageInputStream(stream);
      reader.setInput( iis, true );
      BufferedImage bimage = reader.read(0);
      return bimage;
    } catch (Exception e) {return null;}
  }

	Object prim_createbg(Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
		int x=Logo.anInt(arg1,lc),y=Logo.anInt(arg2,lc);
		int w=Logo.anInt(arg3,lc),h=Logo.anInt(arg4,lc);
		lc.canvas.createBg(x,y,w,h);
		return null;
	}

	Object prim_antialias(Object arg1, LContext lc){
		boolean b = Logo.aBoolean(arg1, lc);
		lc.canvas.antialias = b;
    if(b)lc.canvas.redraw(new Rectangle(0,0,50000,50000));
		return null;
	}

  Object prim_getpixel(Object arg1, Object arg2, LContext lc){
    int x = Logo.anInt(arg1, lc), y = Logo.anInt(arg2, lc);
    return new Integer(pixelimg.getRGB(x,y)&0xffffff);
  }

  Object prim_setpixel(Object arg1, Object arg2, Object arg3, LContext lc){
    int x = Logo.anInt(arg1, lc), y = Logo.anInt(arg2, lc), c = Logo.anInt(arg3, lc);
    pixelimg.setRGB(x,y,c);
    return null;
  }

  Object prim_setratiomask(Object arg1, Object arg2, LContext lc){
    int x = Logo.anInt(arg1, lc), y = Logo.anInt(arg2, lc);
    lc.canvas.setMask(x,y);
    return null;
  }

  Object prim_setpixelimg(Object arg1, LContext lc){
	if(arg1 instanceof BufferedImage) pixelimg = (BufferedImage) arg1;
    else pixelimg = lc.canvas.bg;
    return null;
  }
}
